import json
import os


def get_response(response):
    _response = dict()
    _response['ok'] = response.ok
    _response['status_code'] = response.status_code

    if response.ok:
        try:
            _response['data'] = response.json()
        except ValueError:
            pass
    else:
        try:
            data = json.loads(response.content.decode('utf-8'))
            if 'detail' in data:
                _response['data'] = data.get('detail')
            else:
                _response['data'] = data
        except Exception:
            _response['data'] = 'Unknown error occurred'
    return _response


def recursive_chmod(list_directories):
    for your_dir in list_directories:
        for root, dirs, files in os.walk(your_dir):
            for d in dirs:
                os.chmod(os.path.join(root, d), 0o777)
            for f in files:
                os.chmod(os.path.join(root, f), 0o777)
