import config
from integrator import IntegratorTcp, IntegratorSerial, IntegratorGpio
from sfc_core_requests import SfcRequests


class Manager(object):

    def __init__(self, conf: config.MACHINE):
        self.conf = conf
        self.comunicator = None
        self.client = SfcRequests()

    def callback(self, count=None):
        if self.client.send_count(self.conf.NAME, self.conf.PROCESS, count):
            print('> contagem registrada.')
            return True
        else:
            print("> falha ao enviar contagem.")
            return False

    def _load_config(self):
        if self.conf.PROTOCOL == 'RS232':
            self.comunicator = IntegratorSerial(callback=self.callback)
            self.comunicator.start()

        elif self.conf.PROTOCOL == 'TCP':
            self.comunicator = IntegratorTcp(callback=self.callback)
            self.comunicator.start()

        elif self.conf.PROTOCOL == 'GPIO':
            self.comunicator = IntegratorGpio(callback=self.callback)
            self.comunicator.start()

    def run(self):
        self._load_config()
