import sys

sys.path.insert(0, "..")
import time

from opcua import Server

if __name__ == "__main__":

    server = Server()
    server.set_endpoint("opc.tcp://0.0.0.0:4840/freeopcua/server/")

    uri = "http://bystronic.com/Machine/"
    idx = server.register_namespace(uri)

    objects = server.get_objects_node()

    machine_obj = objects.add_object(idx, "Machine")
    machine_obj.add_variable(idx, "MachineName", "Laser 3")

    data = machine_obj.add_variable(idx, "MachineDataAcquisition", 0)
    data.set_writable()

    server.start()

    try:
        count = 0
        while True:
            time.sleep(3)
            count += 1
            data.set_value(count)
    finally:
        server.stop()
